//
//  DetallRestaurantViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 15/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "DetallRestaurantViewController.h"
#import "TaulaResultatsViewController.h" 
#import "AppDelegate.h" 
#import <sqlite3.h>


@interface DetallRestaurantViewController ()

@end

@implementation DetallRestaurantViewController

@synthesize detailItem=_detailItem;
@synthesize labelNomRest, labelAdreca, labelEmail, labelLocalitat, labelRang, labelTelf, labelWeb, labelNumValor, labelPuntMitjana, imageReque;
@synthesize nomLocalitat, valorRang, valorReq, puntMitjana, numValoracions;
@synthesize botoReserva, botoVeureValoracions;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


//Mètode de càrrega de la vista per mostrar els valors dels diferents camps de l'ítem seleccionat en l'etiqueta o camp assignat. 
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    [self carregarDades]; 
    
    self.labelNomRest.text = [_detailItem valueForKey:@"nom"];
    self.labelAdreca.text = [_detailItem valueForKey:@"adreca"];
    self.labelEmail.text = [_detailItem valueForKey:@"email"];
    self.labelLocalitat.text = nomLocalitat;
    self.labelRang.text = valorRang;
    self.labelTelf.text = [_detailItem valueForKey:@"telf"];
    self.labelWeb.text = [_detailItem valueForKey:@"web"];
    self.labelPuntMitjana.text = [NSString stringWithFormat:@"Puntuació mitjana: %@", puntMitjana];
    self.labelNumValor.text = [NSString stringWithFormat:@"Número de valoracions: %@", numValoracions];
    
    if ( [[_detailItem valueForKey:@"email"] isEqualToString:@"Dada no disponible"]) {
        botoReserva.enabled = NO;
        botoReserva.hidden = YES;
    }
    
    if ([numValoracions isEqualToString:@"0"]) {
        botoVeureValoracions.enabled = NO;
        botoVeureValoracions.hidden =YES; 
    }
    
    NSString *nomImaReq;
    
    if ( [[_detailItem valueForKey:@"requeriments"] integerValue]  == 1) {
        nomImaReq = @"gluten-100.png";
    }
    else if ( [[_detailItem valueForKey:@"requeriments"] integerValue] == 2) {
        nomImaReq=@"lactosa-100.png";
    }
    else {
        nomImaReq=@"logo-v2-57.png";
    }
    
    UIImage *imaReq = [UIImage imageNamed:nomImaReq];
    [imageReque setFrame:CGRectMake(0, 0, 30, 30)];
    self.imageReque.image = imaReq;
    
      
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//Actuaitza l'ítem del qual ha de mostra les dades
- (void)setDetailItem:(id)newDetailItem
{
    if (_detailItem != newDetailItem) {
        _detailItem = newDetailItem;
        
        
        // Update the view.
        [self viewDidLoad];
    }
}


//Els camps requeriment, localitat i rang de preus carreguen valors que corresponen a un identificador. En aquest mètode es consulten les taules corresponents per obtenir el descriptor. 
- (void) carregarDades {
    //restaurants = resulRest;
    
    AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    
    sqlite3 *database;
    sqlite3_stmt *sentencia;
    NSString *sqlLoc = [NSString stringWithFormat:@"select \"nomLocalitat\" from \"localitat\" WHERE \"idLocalitat\"=\"%@\"", [_detailItem valueForKey:@"localitat" ]];
    NSString *sqlRang = [NSString stringWithFormat:@"select \"rangs\" from \"rangPreus\" WHERE \"idRang\"=\"%@\"", [_detailItem valueForKey:@"rang" ]];
    NSString *sqlReq = [NSString stringWithFormat:@"select \"tipusReq\" from \"requeriments\" WHERE \"idReq\"=\"%@\"", [_detailItem valueForKey:@"requeriments" ]];
    NSString *sqlPunt = [NSString stringWithFormat:@"select avg(\"puntuacio\") from \"valoracions\" WHERE \"restaurant\"=\"%@\"", [_detailItem valueForKey:@"idRest" ]];
    NSString *sqlVal = [NSString stringWithFormat:@"select count(\"puntuacio\") from \"valoracions\" WHERE \"restaurant\"=\"%@\"", [_detailItem valueForKey:@"idRest" ]];
    if (sqlite3_open ([appDelegate.dataBasePath UTF8String], &database) == SQLITE_OK){
        if (sqlite3_prepare_v2(database, [sqlLoc UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                nomLocalitat = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
            }
        }
        sqlite3_finalize(sentencia);
        if (sqlite3_prepare_v2(database, [sqlRang UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                valorRang = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
            }
        }
        sqlite3_finalize(sentencia);
        if (sqlite3_prepare_v2(database, [sqlReq UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                valorReq = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
            }
        }
        sqlite3_finalize(sentencia);
        if (sqlite3_prepare_v2(database, [sqlVal UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                numValoracions = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
            }
        }
        sqlite3_finalize(sentencia);
        if ( [numValoracions integerValue]> 0) {
            if (sqlite3_prepare_v2(database, [sqlPunt UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
                while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                    puntMitjana = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
                }
            }
            sqlite3_finalize(sentencia);
        }else {
            puntMitjana = @"Dada no disponible"; 
        }

    }
    sqlite3_close(database);

}


//Mètode que serveix per preparar les transicions a altres vistes en què s'han de traspasar dades
- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {

    //Si la transició és a a la valoració, envia el nom del restaurant
    if ([[segue identifier] isEqualToString:@"segValora"]) {
        ValoraViewController *valoraRest = [segue destinationViewController];
       valoraRest.nomRest = [_detailItem valueForKey:@"nom"];
    }
    
    //Si la transició és a a la reserva, envia el nom del restaurant, l'adreça de correu electrònic i el valor del tipus de requeriment
    if ([[segue identifier] isEqualToString:@"segReserva"]) {
        ReservaViewController *reservaRest = [segue destinationViewController];
        reservaRest.nomRest = [_detailItem valueForKey:@"nom"];
        reservaRest.emailRest = [_detailItem valueForKey:@"email"];
        reservaRest.tipusReq = valorReq;
        //Si el restaurant no té email indicat, apareix un avís indicant-ho.
        if ([[_detailItem valueForKey:@"email"] isEqualToString:@"Dada no disponible"]) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Ho sentim" message:@"Aquest restaurant no disposa de correu electrònic per enviar una reserva" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
            [alert show];
        }
    }
    
    //Si la transició és a al mapa, envia la latitud i longitud del retaurant, el nom, l'adreça i els requeriments 
    if ([[segue identifier] isEqualToString:@"segMap"]) {
        MapaViewController *mapaRest = [segue destinationViewController];
        mapaRest.latRest= [_detailItem valueForKey:@"latRest"];
        mapaRest.longRest= [_detailItem valueForKey:@"longRest"];
        mapaRest.nomRest= [_detailItem valueForKey:@"nom"];
        mapaRest.adreca= [_detailItem valueForKey:@"adreca"];
        mapaRest.idReq = [_detailItem valueForKey:@"requeriments" ];
    }
    
    //Si la transició és a les valoracions, envia el nom i l'identificador del restaurant
    if ([[segue identifier] isEqualToString:@"segValoracions"]) {
        ValoracionsViewController *valoracions = [segue destinationViewController];
        valoracions.idRest= [_detailItem valueForKey:@"idRest"];
        valoracions.nomRest= [_detailItem valueForKey:@"nom"];
        
    }
    

}


@end
