//
//  MapaViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 18/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "MapaViewController.h"

@interface MapaViewController ()
//- (void) configureView;

@end

@implementation MapaViewController

@synthesize longRest, latRest, nomRest, adreca, idReq, mapView;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    mapView.delegate = self; 
    
    //Es configura el mapa a partir dels valors de longitud i latitud del resturant
    MKCoordinateRegion region;
    MKCoordinateSpan span;
    span.latitudeDelta = 0.01;
    span.longitudeDelta = 0.01;
    CLLocationCoordinate2D location;
    location.latitude = [latRest floatValue];
    location.longitude = [longRest floatValue];
    region.span = span;
    region.center = location;
    [mapView setRegion:region animated:YES];
    [mapView regionThatFits:region];
    

    //S'estableixen els valors del nom i adreça per al restaurant quan es mostra el valor del punt
    CLLocationCoordinate2D coordPunt = CLLocationCoordinate2DMake(location.latitude, location.longitude);
    MKPointAnnotation *punt = [[MKPointAnnotation alloc] init];
    [punt setCoordinate:coordPunt];
    [punt setTitle:nomRest];
    [punt setSubtitle:adreca];
    [(MKMapView*)self.view addAnnotation:punt];
    
}

- (void)didReceiveMemoryWarning
{
    [self setMapView:nil]; 
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

//Es configura el format de l'agulla que marca el punt
- (MKAnnotationView *) mapView:(MKMapView *)mapView viewForAnnotation:(id<MKAnnotation>)annotation {
    MKPinAnnotationView *pinView = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"curr"];
    //
    pinView.animatesDrop = YES;
    pinView.canShowCallout = YES;
    
    UIImageView *imaMap = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@""]];
    UIImageView *imaGluten = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"gluten-100.png"]];
    UIImageView *imaLactosa = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"lactosa-100.png"]];
    if ( [idReq integerValue] == 1) {
        imaMap = imaGluten;
    }
    else if ( [idReq integerValue] == 2) {
        imaMap = imaLactosa;
    }
    [imaMap setFrame:CGRectMake(0, 0, 30, 30)];
    pinView.leftCalloutAccessoryView=imaMap;
    
    return pinView;
}


@end
