//
//  NomRestViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 07/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "NomRestViewController.h"
#import <sqlite3.h> 
#import "AppDelegate.h"

@interface NomRestViewController (){
    NSMutableArray *rest;
}

@end

@implementation NomRestViewController

@synthesize nomRestaurantCercat, sqlEnviat, botoCerca;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];

    //Prepara la cadena de text amb l'ordre SQL per cercar el resultat, agafant el nom introduït al quadre de text. 
    
    sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE nomRest= \"%@\"", self.nomRestaurantCercat.text];
    
    botoCerca.enabled = NO;
    botoCerca.hidden = YES; 
    botoCerca.highlighted = NO;
    //botoCerca.backgroundColor = [UIColor redColor];
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

// Mètode que s'executa en finalitzar la introducció del text. Es connecta a la base de dades per consultar si el restaurant que s'ha introduït està a la base de dades. Si troba el restaurant mostra una alerta, si no, en mostra una altra. 

- (IBAction)doneEditing:(id)sender {

    [sender resignFirstResponder];
    
    rest = [[NSMutableArray alloc] init];
    
    AppDelegate *appDelegate = (AppDelegate *) [[UIApplication sharedApplication] delegate];
    
    sqlite3 *dataBase;
    sqlite3_stmt *sentencia;
    

    
    if (sqlite3_open([appDelegate.dataBasePath UTF8String], &dataBase) == SQLITE_OK) {
        
        sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE nomRest= \"%@\"", self.nomRestaurantCercat.text];
        
        if(sqlite3_prepare_v2(dataBase, [sqlEnviat UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) == SQLITE_ROW) {
                
            
                NSMutableDictionary * dic = [[NSMutableDictionary alloc] init];
                NSString  *nom = [NSString stringWithUTF8String:(char *) sqlite3_column_text(sentencia, 0)];
                
                [dic setValue: nom forKey:@"nomRest"];
                
                [rest addObject:dic];
            }
        }else {
            NSLog(@"Error en la creación del SELECT, %@", sqlEnviat);
        }
        sqlite3_finalize(sentencia);
        
    }else{
        NSLog(@"No se ha podido abrir la BD");
    }
    sqlite3_close(dataBase);
    if (rest.count >0) {
        botoCerca.enabled = YES;
        botoCerca.hidden = NO;
        
    }else {
        //Missatge d'alerta que mostra si el restaurant no s'ha trobat
        UIAlertView * alert =
        [[UIAlertView alloc] initWithTitle:@"Ho sentim"
                                   message:@"El restaurant que cerca no ha estat trobat"
                                  delegate:self
                         cancelButtonTitle:@"Fet"
                         otherButtonTitles:nil];
        [alert show];
        botoCerca.enabled = NO;
        botoCerca.hidden = YES;
    }
    

}

//Mètode que serveix per preparar les transicions a altres vistes en què s'han de traspasar dades

- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {

    //Si la transició és per una cerca pel nom, envia la cadena SQL carregada a l'inici
    if ([[segue identifier] isEqualToString:@"segRestTrobat"]) {
        TaulaResultatsViewController *resultCerca = [segue destinationViewController];
        resultCerca.sqlRebut = sqlEnviat;
    }
    
    //Si la transició és per veure tots els restaurants els restaurants, envia la cadena SQL per realitzar aquesta cerca.  
    if ([[segue identifier] isEqualToString:@"cercaTotsRest"]) {
        sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\""];
        TaulaResultatsViewController *resultCerca = [segue destinationViewController];
        resultCerca.sqlRebut = sqlEnviat;
    }
}


@end
