//
//  Picker1ViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 10/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "Picker1ViewController.h"
#import "AppDelegate.h"
#import <sqlite3.h>
#import "Picker2ViewController.h"

@interface Picker1ViewController ()

@end

@implementation Picker1ViewController

@synthesize pickerRequeriment;
NSMutableArray *requeriment;
NSString *requerimentEscollit;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


//En carregar la vista s'inicia un NSMutableArray anomenat requeriment, es desa com a primer objecte l'identificador 0 amb el nom "Qualsevol" i a continuació es carreguen els valors obtingus de la base de dades amb el mètode carregarRequeriments. Es pren com a valor per defecte el 0.

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    requeriment = [[NSMutableArray alloc] init ];

    
    NSMutableDictionary *dic = [[NSMutableDictionary alloc]init];
    [dic setValue:[NSString stringWithFormat:(@"0")] forKey:@"idReq"];
    [dic setValue:[NSString stringWithFormat:(@"Qualsevol")]  forKey:@"tipusReq"];
    [requeriment addObject:dic];
    
    [self carregarRequeriments];
    requerimentEscollit = [[requeriment valueForKey:@"idReq"] objectAtIndex:0];
   
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}



- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(actualizarDatos:) name:UIApplicationDidBecomeActiveNotification object:nil];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIApplicationDidBecomeActiveNotification object:nil];
}

//S'assigna a l'objecte pickerView 1 columna
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView{
    return 1;
}

//S'assigna a l'objecte pickerView tantes de fileres com camps tingui l'objecte requeriment
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component{
    return [requeriment count];
}

//S'assigna a cada filera del pickerView el valor coresponent de requeriment al camp "tipusReq"
- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component{
    
    return [[requeriment valueForKey:@"tipusReq"] objectAtIndex:row];
}

//Quan se selecciona una filera, es pren el valor "idReq" que correspon 
- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component{
    requerimentEscollit = [[requeriment valueForKey:@"idReq"] objectAtIndex:row];
}


//Aquest mètode carrega consulta la base de dades i carrega tots els identificadors i els valors de la taula requeriments en el NSMutableArray requeriments. 
- (void) carregarRequeriments {
    
    AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    
    sqlite3 *database;
    sqlite3_stmt *sentencia;
    
    if (sqlite3_open ([appDelegate.dataBasePath UTF8String], &database) == SQLITE_OK){
        NSString *sentenciaSQL = [NSString stringWithFormat:@"select * from \"requeriments\""];
        if (sqlite3_prepare_v2(database, [sentenciaSQL UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                NSMutableDictionary *dic = [[NSMutableDictionary alloc]init];
                NSString *idReq = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
                [dic setValue:idReq forKey:@"idReq"];
                NSString *tipusReq = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 1)];
                [dic setValue:tipusReq forKey:@"tipusReq"];
                [requeriment addObject:dic];
            }
        }
        sqlite3_finalize(sentencia);
    }
    sqlite3_close(database);
    [requeriment count];
}

//Mètode que serveix per preparar les transicions a altres vistes en què s'han de traspasar dades
- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{
    
    //Passa a la següent pantalla l'identificador del requeriment escollit
    if ([[segue identifier] isEqualToString:@"segCercaLoc"]) {
        Picker2ViewController *segonPick = [segue destinationViewController];
        segonPick.requeriment = requerimentEscollit;
    }
}

@end
