//
//  Picker2ViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 11/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "Picker2ViewController.h"
#import "AppDelegate.h"
#import <sqlite3.h>
#import "Picker1ViewController.h"
#import "Picker3ViewController.h"



@interface Picker2ViewController ()

@end

@implementation Picker2ViewController

@synthesize pickerLocalitat;
@synthesize requeriment;
NSMutableArray *localitat;
NSString *localitatEscollida;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


//En carregar la vista s'inicia un NSMutableArray anomenat localitat, es desa com a primer objecte l'identificador 0 amb el nom "Qualsevol" i a continuació es carreguen els valors obtingus de la base de dades amb el mètode carregarLocalitats. Es pren com a valor per defecte el 0.
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    localitat = [[NSMutableArray alloc] init ];
    
    NSMutableDictionary *dic = [[NSMutableDictionary alloc]init];
    [dic setValue:[NSString stringWithFormat:(@"0")] forKey:@"idLoc"];
    [dic setValue:[NSString stringWithFormat:(@"Qualsevol")]  forKey:@"nomLoc"];
    [localitat addObject:dic];
    
    [self carregarLocalitats];
    
    localitatEscollida = [[localitat valueForKey:@"idLoc"] objectAtIndex:0];

}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(actualizarDatos:) name:UIApplicationDidBecomeActiveNotification object:nil];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIApplicationDidBecomeActiveNotification object:nil];
}

//S'assigna a l'objecte pickerView 1 columna
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView{
    return 1;
}

//S'assigna a l'objecte pickerView tantes fileres com camps tingui l'objecte localitat 
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component{
    return [localitat count];
}


//S'assigna a cada filera del pickerView el valor corresponent de localitat al camp nomLoc
- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component{
    return [[localitat valueForKey:@"nomLoc"] objectAtIndex:row];
}


//Quan se selecciona una filera es pren el valor "idLoc" que correspon
- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component{
    localitatEscollida = [[localitat valueForKey:@"idLoc"] objectAtIndex:row];
}

//Aquest mètode carrega consulta la base de dades i carrega tots els identificadors i els valors de la taula localitats en el NSMutableArray localitat.

- (void) carregarLocalitats {
    //restaurants = resulRest;
    
    AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    
    sqlite3 *database;
    sqlite3_stmt *sentencia;
    
    if (sqlite3_open ([appDelegate.dataBasePath UTF8String], &database) == SQLITE_OK){
        NSString *sentenciaSQL = [NSString stringWithFormat:@"select * from \"localitat\""];
        if (sqlite3_prepare_v2(database, [sentenciaSQL UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                NSMutableDictionary *dic = [[NSMutableDictionary alloc]init];
                NSString *idLoc = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
                [dic setValue:idLoc forKey:@"idLoc"];
                NSString *nomLoc = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 1)];
                [dic setValue:nomLoc forKey:@"nomLoc"];
                [localitat addObject:dic];
            }
        }
        sqlite3_finalize(sentencia);
    }
    sqlite3_close(database);
    [localitat count];
}


//Mètode que serveix per preparar les transicions a altres vistes en què s'han de traspasar dades

- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender{

    //Passa a la següent pantalla l'identificador de la localitat escollida i l'identificador del requeriment rebut de la pantalla anterior
    if ([[segue identifier] isEqualToString:@"segCercaPreus"]) {
        Picker3ViewController *tercerPick = [segue destinationViewController];
        tercerPick.requeriment3 = requeriment;
        tercerPick.localitat2 = localitatEscollida;
        
    }
}

@end
