//
//  Picker3ViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 11/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "Picker3ViewController.h"
#import "AppDelegate.h"
#import <sqlite3.h>

@interface Picker3ViewController ()

@end

@implementation Picker3ViewController

@synthesize pickerPreus;
@synthesize requeriment3, localitat2;

NSMutableArray *preus;
NSString *preusEscollits;



- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}


//En carregar la vista s'inicia un NSMutableArray anomenat preus, es desa com a primer objecte l'identificador 0 amb el nom "Qualsevol" i a continuació es carreguen els valors obtingus de la base de dades amb el mètode carregarPreus. Es pren com a valor per defecte el 0.
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    preus = [[NSMutableArray alloc] init ];

    
    NSMutableDictionary *dic = [[NSMutableDictionary alloc]init];
    [dic setValue:[NSString stringWithFormat:(@"0")] forKey:@"idRang"];
    [dic setValue:[NSString stringWithFormat:(@"Qualsevol")]  forKey:@"rang"];
    [preus addObject:dic];
    
    [self carregarPreus];
    
    preusEscollits = [[preus valueForKey:@"idRang"] objectAtIndex:0];
   
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(actualizarDatos:) name:UIApplicationDidBecomeActiveNotification object:nil];
}

- (void)viewDidDisappear:(BOOL)animated {
    [super viewDidDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIApplicationDidBecomeActiveNotification object:nil];
}

//S'assigna a l'objecte pickerView 1 columna
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView{
    return 1;
}

//S'assigna a l'objecte pickerView tantes fileres com camps tingui l'objecte preus
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component{
    return [preus count];
}

//S'assigna a cada filera del pickerView el valor corresponent de preus al camp rang
- (NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component{
    return [[preus valueForKey:@"rang"] objectAtIndex:row];
}

//Quan se selecciona una filera es pren el valor "idRang" que correspon
- (void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component{
    preusEscollits = [[preus valueForKey:@"idRang"] objectAtIndex:row];
}

//Aquest mètode carrega consulta la base de dades i carrega tots els identificadors i els valors de la taula rangPreus en el NSMutableArray preus.
- (void) carregarPreus {
    
    AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    
    sqlite3 *database;
    sqlite3_stmt *sentencia;
    
    if (sqlite3_open ([appDelegate.dataBasePath UTF8String], &database) == SQLITE_OK){
        NSString *sentenciaSQL = [NSString stringWithFormat:@"select * from \"rangPreus\""];
        if (sqlite3_prepare_v2(database, [sentenciaSQL UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                NSMutableDictionary *dic = [[NSMutableDictionary alloc]init];
                NSString *idRang = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
                [dic setValue:idRang forKey:@"idRang"];
                NSString *rang = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 1)];
                [dic setValue:rang forKey:@"rang"];
                [preus addObject:dic];
            }
        }
        sqlite3_finalize(sentencia);
    }
    sqlite3_close(database);
    [preus count];
    
}

//Mètode que serveix per preparar les transicions a altres vistes en què s'han de traspasar dades
- (void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {

  
    //Es crea un string per comparar quan algun dels valors sigui 0
    NSString *zero = [NSString stringWithFormat:(@"0")];
    
    //Es crea una sentència sql per cercar a la taula restaurants segons els valors corresponents als valors triats. Quan algun dels valors és igual a 0, la sentència sql ha d'obviar el camps al qual correspon. Així, si tots tres camps són igual a 0, la sentència ha de demanar tots els registres de la taula. Si tots tres tenen camps diferents a 0, hi haurà restriccions en els tres camps localitat, rangPr i requeriments. 
    
    NSString *sqlEnviat;
    if ([localitat2 isEqualToString:zero]) {
        if ([requeriment3 isEqualToString:zero]) {
            if ([preusEscollits isEqualToString:zero]) {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\""];
            }else {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE \"rangPr\"=\"%@\"", preusEscollits];
            }
        }else {
            if ([preusEscollits isEqualToString:zero]) {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE \"requeriments\"=\"%@\"", requeriment3];
            }else {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE \"requeriments\"=\"%@\" AND \"rangPr\"=\"%@\"", requeriment3, preusEscollits];
            }
        }
    } else {
        if ([requeriment3 isEqualToString:zero]) {
            if ([preusEscollits isEqualToString:zero]) {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE \"localitat\"=\"%@\"", localitat2];
            }else {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE \"localitat\"=\"%@\" AND \"rangPr\"=\"%@\"", localitat2, preusEscollits];
            }
        }else {
            if ([preusEscollits isEqualToString:zero]) {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE \"localitat\"=\"%@\" AND \"requeriments\"=\"%@\"", localitat2, requeriment3];
            }else {
                sqlEnviat = [NSString stringWithFormat:@"select * from \"restaurants\" WHERE \"localitat\"=\"%@\" AND \"requeriments\"=\"%@\" AND \"rangPr\"=\"%@\"", localitat2, requeriment3, preusEscollits];
            }
        }
    }
    
    //La sentència l'string amb la sentència sql generada és l'objecte que s'envia a la vista TaulaResultatsViewController. 

    if ([[segue identifier] isEqualToString:@"segCercaRest"]) {
        TaulaResultatsViewController *resultCerca = [segue destinationViewController];
        resultCerca.sqlRebut = sqlEnviat;
    }
}

@end
