//
//  PropRestViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 12/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "PropRestViewController.h"
//#import "MailPropostaViewController.h"

@interface PropRestViewController ()

@end

@implementation PropRestViewController

@synthesize scrollView;

@synthesize textNomRestProp, textAdreRestProp, textPreusRestProp, textMenusRestProp, textPersonaRestProp, textFieldActual;


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}


//Mètode que detecta quan es toca sobre la zona de l'scroolView
- (void) scrollViewTapped {
    [[self view] endEditing:YES]; 
}

//Mètode que assigna a textFieldActual el camp de text sobre el qual comença l'edició d'un camp de text
- (void) textFieldDidBeginEditing:(UITextField *) textField {
    textFieldActual=textField;
}

//Mètode que allibera el textFieldActual quan finalitza l'edició d'un camp de text
- (void) textFieldDidEndEditing:(UITextField *) textField {
    textFieldActual=nil;
}

//Mètode que estableix el camp sobre el qual el teclat quan es prem la tecla "return". S'ha programat per establir un ordre i segueixi fins al darrer camp. 
-(BOOL) textFieldShouldReturn:(UITextField *) textField {

    if (textField == textNomRestProp) {
        [textField resignFirstResponder];
        [textAdreRestProp becomeFirstResponder];
    }
    else if (textField == textAdreRestProp) {
        [textField resignFirstResponder];
        [textPreusRestProp becomeFirstResponder];
    }
    else if (textField == textPreusRestProp) {
        [textField resignFirstResponder];
        [textMenusRestProp becomeFirstResponder];
    }
    else if (textField == textMenusRestProp) {
        [textField resignFirstResponder];
        [textPersonaRestProp becomeFirstResponder];
    }
    else if (textField == textPersonaRestProp) {
        [textField resignFirstResponder];
    }
    return YES;
}

//Mètode per capturar l'aparició del teclat i crea un espai per moure l'scrollView, de manera que el camp sobre el qual s'edita no quedi tapat pel teclat.
- (void) surtTeclat:(NSNotification *) avis {
    
    NSDictionary * infoAvis = [avis userInfo];
    CGSize midaTeclat = [[infoAvis objectForKey:UIKeyboardFrameBeginUserInfoKey] CGRectValue].size;
    
    UIEdgeInsets edgeInsets = UIEdgeInsetsMake(0, 0, midaTeclat.height, 0);
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    
    [[self scrollView] scrollRectToVisible:[self textFieldActual].frame animated:YES];
    
}

//Mètode per capturar la desaparició del teclat i eliminar l'espai que ha mogut l'scrollView, de manera que es torni a veure tota la pantalla
- (void) ocultaTeclat:(NSNotification *)avis {
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.3];
    UIEdgeInsets edgeInsets = UIEdgeInsetsZero;
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    [UIView commitAnimations]; 	
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(surtTeclat:)
                                                 name:UIKeyboardWillShowNotification
                                               object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(ocultaTeclat:)
                                                 name:UIKeyboardWillHideNotification
                                               object:nil];
    UITapGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(scrollViewTapped)];
    
    [tapRecognizer setCancelsTouchesInView:NO];
    [[self scrollView] addGestureRecognizer:tapRecognizer]; 
    
    [[self scrollView] setContentSize:[[self view] frame].size];
    

}


- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardWillShowNotification
                                                  object:nil];
    
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardDidHideNotification
                                                  object:nil];
}


- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}


- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}


//Aquest mètode gestiona el controlador per l'edició d'un correu electrònic.
- (void)mailComposeController:(MFMailComposeViewController*)controller
          didFinishWithResult:(MFMailComposeResult)result
                        error:(NSError*)error {
    [controller dismissViewControllerAnimated:YES completion:nil];
}

//Mètode que s'activa en tocar el botó d'enviar.
- (IBAction) btnSend:(id)sender {

    if ([textNomRestProp.text isEqualToString:@""]){
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar del nom del restaurant que es vol proposar" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textNomRestProp.text isEqualToString:@"Nom del restaurant"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar del nom del restaurant que es vol proposar" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textAdreRestProp.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal dir l'adreça del restaurant proposat" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textAdreRestProp.text isEqualToString:@"Adreça del restaurant"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal dir l'adreça del restaurant proposat" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textPreusRestProp.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un rang de preus del restaurant proposat" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textPreusRestProp.text isEqualToString:@"Rang de preus"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un rang de preus del restaurant proposat" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textMenusRestProp.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar dels menús especials que ofereix el restaurant proposat" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textMenusRestProp.text isEqualToString:@"Tipus de menús"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar dels menús especials que ofereix el restaurant proposat" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textPersonaRestProp.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar del nom de la persona que proposa el restaurant" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textPersonaRestProp.text isEqualToString:@"Nom de la persona que proposa"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar del nom de la persona que proposa el restaurant" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else {
        //Es crea un string amb el cos del correu electrònic, prenent els valors dels camps de text que ha emplenat l'usuari
        NSString *strMail = [NSString stringWithFormat:@"Sóc %@ i vull proposar el següent restaurant: %@, amb adreça a %@, preus %@. Tenen menús especials %@.", self.textPersonaRestProp.text, self.textNomRestProp.text, self.textAdreRestProp.text, textPreusRestProp.text, textMenusRestProp.text ];
        
        MFMailComposeViewController *picker =
        [[MFMailComposeViewController alloc] init];
        picker.mailComposeDelegate = self;
        
        //Es carreguen les destinataris, l'assumpte i el cos del missatge.
        NSArray *recipients = [NSArray arrayWithObject:@"prova@restaurant.com"  ];
        [picker setToRecipients:recipients];
        [picker setSubject:@"Proposta de nou restaurant"];
        [picker setMessageBody:strMail isHTML:NO];
        [self presentViewController:picker animated:YES completion:nil];
    }
}

@end

