//
//  ReservaViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 17/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "ReservaViewController.h"

@interface ReservaViewController ()

@end

@implementation ReservaViewController

@synthesize pickerData, nomRest, emailRest, textEmailContacte, textNomClient, textNumCom, dataReserva, tipusReq;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    //Es captura, per defecte la data actual
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateStyle:NSDateFormatterFullStyle];
    [dateFormatter setTimeStyle:NSDateFormatterShortStyle];
    NSLocale *esLocale = [[NSLocale alloc] initWithLocaleIdentifier:@"ca_CA"];
    [dateFormatter setLocale:esLocale];
    NSString * selected = [dateFormatter stringFromDate:[pickerData date]];
    NSString * date = [selected description];
    dataReserva = date;
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
//Mètode que estableix el camp sobre el qual el teclat quan es prem la tecla "return". S'ha programat per establir un ordre i segueixi fins al darrer camp. 
- (BOOL) textFieldShouldReturn: (UITextField *) campActiu {
    if (campActiu == textNomClient) {
        [campActiu resignFirstResponder];
        [textNumCom becomeFirstResponder];
    }
    else if (campActiu == textNumCom) {
        [campActiu resignFirstResponder];
        [textEmailContacte becomeFirstResponder];
    }
    else if (campActiu == textEmailContacte) {
        [campActiu resignFirstResponder];
    }
    return YES;
}


//Mètode que captura la data a través del pickerView. S'ha utilitzat el format de data a català. 
-(IBAction)displayDate:(id)sender{
    NSDateFormatter *dateFormatter = [[NSDateFormatter alloc] init];
    [dateFormatter setDateStyle:NSDateFormatterFullStyle];
    [dateFormatter setTimeStyle:NSDateFormatterShortStyle];
    NSLocale *esLocale = [[NSLocale alloc] initWithLocaleIdentifier:@"ca_CA"];
    [dateFormatter setLocale:esLocale];
    NSString * selected = [dateFormatter stringFromDate:[pickerData date]];
    NSString * date = [selected description];
    dataReserva = date;
}

//Aquest mètode gestiona el controlador per l'edició d'un correu electrònic.
- (void)mailComposeController:(MFMailComposeViewController*)controller
          didFinishWithResult:(MFMailComposeResult)result
                        error:(NSError*)error {
    [controller dismissViewControllerAnimated:YES completion:nil];
}

//Mètode que s'activa en tocar el botó d'enviar.
- (IBAction)botoReserva:(id)sender {
    
    if ([textNomClient.text isEqualToString:@"Nom del Client"]){
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un nom de client per poder realitzar la reserva" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textNomClient.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un nom de client per poder realitzar la reserva" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textNumCom.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar del número de comensals per poder realitzar la reserva" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textEmailContacte.text isEqualToString:@"Correu electrònic de contacte"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un correu electrònic de contacte per poder realitzar la reserva" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textEmailContacte.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un correu electrònic de contacte per poder realitzar la reserva" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else {
        //Es crea un string amb el cos del correu electrònic, prenent els valors dels camps de text que ha emplenat l'usuari
        NSString *strMail = [NSString stringWithFormat:@"Sóc %@ i vull reservar una taula al restaurant %@ per %@ persones. Ens ha interessat el seu restaurant perquè tenen menús especials %@. La reserva seria per la següent data: %@. El correu electrònic de contacte seria: %@.", self.textNomClient.text, nomRest, self.textNumCom.text, tipusReq, dataReserva, self.textEmailContacte.text];
        
        MFMailComposeViewController *picker =
        [[MFMailComposeViewController alloc] init];
        picker.mailComposeDelegate = self;
        
        //Es carreguen les destinataris, l'assumpte i el cos del missatge.
        NSArray *recipients = [NSArray arrayWithObject:emailRest ];
        NSArray *gestorApp = [NSArray arrayWithObject:@"prova@restaurant.com"  ];
        [picker setToRecipients:recipients];
        [picker setCcRecipients:gestorApp],
        [picker setSubject:@"Reserva Restaurant"];
        [picker setMessageBody:strMail isHTML:NO];
        [self presentViewController:picker animated:YES completion:nil];
    }

}

@end
