//
//  ValoraViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 16/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "ValoraViewController.h"
#import "DetallRestaurantViewController.h"

@interface ValoraViewController ()

@end

@implementation ValoraViewController

@synthesize scrollView; 

@synthesize textPunt, textNom, textComentari, textFieldActual, nomRest, labelRest;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    //Es carrega el nom del restaurant que s'està valorant 
    self.labelRest.text = nomRest;
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(surtTeclat:)
                                                 name:UIKeyboardWillShowNotification
                                               object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(ocultaTeclat:)
                                                 name:UIKeyboardWillHideNotification
                                               object:nil];
    UITapGestureRecognizer *tapRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(scrollViewTapped)];
    
    [tapRecognizer setCancelsTouchesInView:NO];
    [[self scrollView] addGestureRecognizer:tapRecognizer];
    
    [[self scrollView] setContentSize:[[self view] frame].size];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
    
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardWillShowNotification
                                                  object:nil];
    
    [[NSNotificationCenter defaultCenter] removeObserver:self
                                                    name:UIKeyboardDidHideNotification
                                                  object:nil];
}


- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}


- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


//Mètode que detecta quan es toca sobre la zona de l'scroolView
- (void) scrollViewTapped {
    [[self view] endEditing:YES];
}


//Mètode que assigna a textFieldActual el camp de text sobre el qual comença l'edició d'un camp de text
- (void) textFieldDidBeginEditing:(UITextField *) textField {
    textFieldActual=textField;
}

//Mètode que allibera el textFieldActual quan finalitza l'edició d'un camp de text
- (void) textFieldDidEndEditing:(UITextField *) textField {
    textFieldActual=nil;
}


//Mètode que estableix el camp sobre el qual el teclat quan es prem la tecla "return". S'ha programat per establir un ordre i segueixi fins al darrer camp. 
-(BOOL) textFieldShouldReturn:(UITextField *) textFieldView {
    if (textFieldView == textPunt) {
        [textFieldView resignFirstResponder];
        [textNom becomeFirstResponder];
    }
    else if (textFieldView == textNom) {
        [textFieldView resignFirstResponder];
        [textComentari becomeFirstResponder];
    }
    else if (textFieldView == textComentari) {
        [textFieldView resignFirstResponder];
    }
    return YES;
}

//Mètode per capturar l'aparició del teclat i crea un espai per moure l'scrollView, de manera que el camp sobre el qual s'edita no quedi tapat pel teclat.
- (void) surtTeclat:(NSNotification *) avis {
    
    NSDictionary * infoAvis = [avis userInfo];
    CGSize midaTeclat = [[infoAvis objectForKey:UIKeyboardFrameBeginUserInfoKey] CGRectValue].size;
    
    UIEdgeInsets edgeInsets = UIEdgeInsetsMake(0, 0, midaTeclat.height, 0);
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    
    [[self scrollView] scrollRectToVisible:[self textFieldActual].frame animated:YES];
    
}

//Mètode per capturar la desaparició del teclat i eliminar l'espai que ha mogut l'scrollView, de manera que es torni a veure tota la pantalla
- (void) ocultaTeclat:(NSNotification *)avis {
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.3];
    UIEdgeInsets edgeInsets = UIEdgeInsetsZero;
    [[self scrollView] setContentInset:edgeInsets];
    [[self scrollView] setScrollIndicatorInsets:edgeInsets];
    [UIView commitAnimations];
}


//Aquest mètode gestiona el controlador per l'edició d'un correu electrònic.
- (void)mailComposeController:(MFMailComposeViewController*)controller
          didFinishWithResult:(MFMailComposeResult)result
                        error:(NSError*)error {
    [controller dismissViewControllerAnimated:YES completion:nil];
}

//Mètode que s'activa en tocar el botó d'enviar.
- (IBAction)botoEnviar:(id)sender {
    
    if ([textPunt.text isEqualToString:@""]){
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal donar una puntuació entre 0 i 10 al restaurant" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textPunt.text intValue] > 10 ) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal donar una puntuació entre 0 i 10 al restaurant" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textNom.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un nom de de la persona que valora" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textNom.text isEqualToString:@"Nom de la persona que valora"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal informar d'un nom de de la persona que valora" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textComentari.text isEqualToString:@""]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal fer un comentari de valoració per motivar la puntuació" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else if ([textComentari.text isEqualToString:@"Comentari"]) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Informació incompleta" message:@"Cal fer un comentari de valoració per motivar la puntuació" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    } else {
        
        //Es crea un string amb el cos del correu electrònic, prenent els valors dels camps de text que ha emplenat l'usuari
        NSString *strMail = [NSString stringWithFormat:@"Sóc %@ i vull valorar el següent restaurant: %@. La puntuació que li atorgo és de %@. %@.", self.textNom.text, nomRest, self.textPunt.text, textComentari.text];
        
        MFMailComposeViewController *picker =
        [[MFMailComposeViewController alloc] init];
        picker.mailComposeDelegate = self;
        
        //Es carreguen les destinataris, l'assumpte i el cos del missatge.
        NSArray *recipients = [NSArray arrayWithObject:@"prova@restaurant.com"  ];
        [picker setToRecipients:recipients];
        [picker setSubject:@"Valoració Restaurants"];
        [picker setMessageBody:strMail isHTML:NO];
        [self presentViewController:picker animated:YES completion:nil];
        
    }
}
@end
