//
//  ValoracionsViewController.m
//  OnTrobarMenus
//
//  Created by Santiago Herrero Blanco on 19/05/13.
//  Copyright (c) 2013 Santiago Herrero Blanco. All rights reserved.
//

#import "ValoracionsViewController.h"
#import "AppDelegate.h"
#import <sqlite3.h>
#import "ValoracionsCell.h"

@interface ValoracionsViewController () {
    NSMutableArray *valoracions;
}

@end

@implementation ValoracionsViewController

@synthesize idRest, nomRest, labelPuntuacio;

- (id)initWithStyle:(UITableViewStyle)style
{
    self = [super initWithStyle:style];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    
    valoracions = [[NSMutableArray alloc] init];
    
    [self carregarValoracions]; 

    // Uncomment the following line to preserve selection between presentations.
    // self.clearsSelectionOnViewWillAppear = NO;
 
    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // Return the number of rows in the section.
    return [valoracions count];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    //S'utilitza el tipus de cel·la creat amb la vista ValoracionsCell, que permet posar tres camps de text
    ValoracionsCell *cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    
    NSDictionary *dic = [valoracions objectAtIndex:indexPath.row];
    
    
    cell.labelComentari.text = [dic objectForKey:@"comentari"];
    cell.labelNom.text = [dic objectForKey:@"nomValorador"];
    cell.labelPuntuacio.text = [dic objectForKey:@"puntuacio"];
    
    return cell;
}



#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     */
}


//S'ampliar l'alçada de la filera per tal que coindicideixi amb la de ValoracionsCell
- (CGFloat) tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    return 90; 
}


//El mètode accedeix a la taula valoracions de la base de dades i desa en el NSMutableArray els registres corresponents als de la taula. Les valoracions es mostren en ordre descendent
- (void) carregarValoracions {

    AppDelegate *appDelegate = (AppDelegate *)[[UIApplication sharedApplication] delegate];
    
    sqlite3 *database;
    sqlite3_stmt *sentencia;
    NSString *sqlVal = [NSString stringWithFormat:@"select * from \"valoracions\" WHERE \"restaurant\"=\"%@\" ORDER BY \"puntuacio\" DESC", idRest];
    
    if (sqlite3_open ([appDelegate.dataBasePath UTF8String], &database) == SQLITE_OK){
        NSString *sentenciaSQL = sqlVal; 
        if (sqlite3_prepare_v2(database, [sentenciaSQL UTF8String], -1, &sentencia, NULL) == SQLITE_OK) {
            while (sqlite3_step(sentencia) ==SQLITE_ROW) {
                NSMutableDictionary *dic = [[NSMutableDictionary alloc]init];
                NSString *idVal = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 0)];
                [dic setValue:idVal forKey:@"idVal"];
                NSString *nomValorador = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 2)];
                [dic setValue:nomValorador forKey:@"nomValorador"];
                NSString *puntuacio = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 3)];
                [dic setValue:puntuacio forKey:@"puntuacio"];
                NSString *comentari = [NSString stringWithUTF8String:(char *)sqlite3_column_text(sentencia, 4)];
                [dic setValue:comentari forKey:@"comentari"];
                [valoracions addObject:dic];
            }
        }
        sqlite3_finalize(sentencia);
    }
    sqlite3_close(database);
    [valoracions count];
    
    //Si el restaurant no té valoracions, apareix un avís indicant-ho.  
    if ([valoracions count] == 0) {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Ho sentim" message:@"No s'han trobat valoracions per a aquest restaurant" delegate:nil cancelButtonTitle:@"Acceptar" otherButtonTitles:nil, nil];
        [alert show];
    }
}

@end
